# coding: utf-8

"""
    Platform API

    _OpenAPI specification for the **Platform API** of **Empire**, the allocation and nomination platform of BritNed_  ---  Additional documentation available in the API's [GitHub repository](https://github.com/britned/empire-platform-api) 

    The version of the OpenAPI document: 6.0.1
    Contact: britned.info@britned.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List
from empire_platform_api_public_client.models.auction import Auction
from empire_platform_api_public_client.models.buy_now_offer_overview_item import BuyNowOfferOverviewItem
from typing import Optional, Set
from typing_extensions import Self

class AuctionOverview(BaseModel):
    """
    AuctionOverview
    """ # noqa: E501
    auctions: List[Auction]
    buy_now_offers: List[BuyNowOfferOverviewItem] = Field(alias="buyNowOffers")
    __properties: ClassVar[List[str]] = ["auctions", "buyNowOffers"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AuctionOverview from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in auctions (list)
        _items = []
        if self.auctions:
            for _item_auctions in self.auctions:
                if _item_auctions:
                    _items.append(_item_auctions.to_dict())
            _dict['auctions'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in buy_now_offers (list)
        _items = []
        if self.buy_now_offers:
            for _item_buy_now_offers in self.buy_now_offers:
                if _item_buy_now_offers:
                    _items.append(_item_buy_now_offers.to_dict())
            _dict['buyNowOffers'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AuctionOverview from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "auctions": [Auction.from_dict(_item) for _item in obj["auctions"]] if obj.get("auctions") is not None else None,
            "buyNowOffers": [BuyNowOfferOverviewItem.from_dict(_item) for _item in obj["buyNowOffers"]] if obj.get("buyNowOffers") is not None else None
        })
        return _obj


