# coding: utf-8

"""
    Platform API

    _OpenAPI specification for the **Platform API** of **Empire**, the allocation and nomination platform of BritNed_  ---  Additional documentation available in the API's [GitHub repository](https://github.com/britned/empire-platform-api) 

    The version of the OpenAPI document: 6.0.1
    Contact: britned.info@britned.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Union
from typing_extensions import Annotated
from empire_platform_api_public_client.models.credit_utilization_overview_data import CreditUtilizationOverviewData
from empire_platform_api_public_client.models.unpaid_invoices_overview_data import UnpaidInvoicesOverviewData
from typing import Optional, Set
from typing_extensions import Self

class FinanceOverview(BaseModel):
    """
    FinanceOverview
    """ # noqa: E501
    credit_cover: Union[Annotated[float, Field(multiple_of=0.01, strict=True)], Annotated[int, Field(strict=True)]] = Field(description="Currency value in Euros (€), accepted with a precision of maximum 2 decimal places", alias="creditCover")
    unpaid_invoices: UnpaidInvoicesOverviewData = Field(alias="unpaidInvoices")
    credit_utilization: CreditUtilizationOverviewData = Field(alias="creditUtilization")
    credit_limit: Union[Annotated[float, Field(multiple_of=0.01, strict=True)], Annotated[int, Field(strict=True)]] = Field(description="Currency value in Euros (€), accepted with a precision of maximum 2 decimal places", alias="creditLimit")
    __properties: ClassVar[List[str]] = ["creditCover", "unpaidInvoices", "creditUtilization", "creditLimit"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of FinanceOverview from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of unpaid_invoices
        if self.unpaid_invoices:
            _dict['unpaidInvoices'] = self.unpaid_invoices.to_dict()
        # override the default output from pydantic by calling `to_dict()` of credit_utilization
        if self.credit_utilization:
            _dict['creditUtilization'] = self.credit_utilization.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of FinanceOverview from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "creditCover": obj.get("creditCover"),
            "unpaidInvoices": UnpaidInvoicesOverviewData.from_dict(obj["unpaidInvoices"]) if obj.get("unpaidInvoices") is not None else None,
            "creditUtilization": CreditUtilizationOverviewData.from_dict(obj["creditUtilization"]) if obj.get("creditUtilization") is not None else None,
            "creditLimit": obj.get("creditLimit")
        })
        return _obj


